## nheko 0.6.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

option(APPVEYOR_BUILD "Build on appveyor" OFF)
option(ASAN "Compile with address sanitizers" OFF)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

add_definitions(-DBOOST_MPL_LIMIT_LIST_SIZE=30)
add_definitions(-DBOOST_MPL_CFG_NO_PREPROCESSED_HEADERS)

include(GNUInstallDirs)

# Include Qt basic functions
include(QtCommon)

project(nheko LANGUAGES C CXX)
set(CPACK_PACKAGE_VERSION_MAJOR "0")
set(CPACK_PACKAGE_VERSION_MINOR "6")
set(CPACK_PACKAGE_VERSION_PATCH "1")
set(PROJECT_VERSION_MAJOR ${CPACK_PACKAGE_VERSION_MAJOR})
set(PROJECT_VERSION_MINOR ${CPACK_PACKAGE_VERSION_MINOR})
set(PROJECT_VERSION_PATCH ${CPACK_PACKAGE_VERSION_PATCH})

# Set PROJECT_VERSION_PATCH & PROJECT_VERSION_TWEAK to 0 if not present
# Needed by add_project_meta.
fix_project_version()

# Set additional project information
set(COMPANY "Nheko")
set(COPYRIGHT "Copyright (c) 2018 Nheko Contributors")
set(IDENTIFIER "com.github.mujx.nheko")

add_project_meta(META_FILES_TO_INCLUDE)

if(APPLE)
    set(OPENSSL_ROOT_DIR /usr/local/opt/openssl)
endif()

if(NOT MSVC AND NOT APPLE)
  set(THREADS_PREFER_PTHREAD_FLAG ON)
  find_package(Threads REQUIRED)
endif()

if (BUILD_DOCS)
    find_package(Doxygen)

    if (DOXYGEN_FOUND)
        set(DOXYGEN_IN ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Doxyfile.in)
        set(DOXYGEN_OUT ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

        configure_file(${DOXYGEN_IN} ${DOXYGEN_OUT})

        add_custom_target(docs ALL
            COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYGEN_OUT}
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
            COMMENT "Generating API documentation with Doxygen"
            VERBATIM )
    else (DOXYGEN_FOUND)
        message("Doxygen need to be installed to generate the doxygen documentation")
    endif (DOXYGEN_FOUND)
endif()


#
# LMDB
#
include(LMDB)

#
# Discover Qt dependencies.
#
find_package(Qt5 COMPONENTS Core Widgets LinguistTools Concurrent Svg Multimedia REQUIRED)
find_package(Qt5DBus)

if (APPLE)
    find_package(Qt5MacExtras REQUIRED)
endif(APPLE)

if (Qt5Widgets_FOUND)
    if (Qt5Widgets_VERSION VERSION_LESS 5.7.0)
        message(STATUS "Qt version ${Qt5Widgets_VERSION}")
        message(WARNING "Minimum supported Qt5 version is 5.7!")
    endif()
endif(Qt5Widgets_FOUND)

#
# Set up compiler flags.
#
if (NOT MSVC)
    set(CMAKE_C_COMPILER gcc)
endif(NOT MSVC)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
if(NOT MSVC)
  set(
    CMAKE_CXX_FLAGS
    "${CMAKE_CXX_FLAGS} \
        -Wall \
        -Wextra \
        -Werror \
        -pipe \
        -pedantic \
        -fsized-deallocation \
        -fdiagnostics-color=always \
        -Wunreachable-code"
    )
    if (NOT CMAKE_COMPILER_IS_GNUCXX)
        # -Wshadow is buggy and broken in GCC, so do not enable it.
        # see https://gcc.gnu.org/bugzilla/show_bug.cgi?id=79328
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wshadow")
    endif()
endif()

if(NOT (CMAKE_BUILD_TYPE OR CMAKE_CONFIGURATION_TYPES))
    set(CMAKE_BUILD_TYPE "Debug" CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
    message("Setting build type to '${CMAKE_BUILD_TYPE}'")
else(NOT (CMAKE_BUILD_TYPE OR CMAKE_CONFIGURATION_TYPES))
    message("Build type set to '${CMAKE_BUILD_TYPE}'")
endif(NOT (CMAKE_BUILD_TYPE OR CMAKE_CONFIGURATION_TYPES))

find_program(GIT git)
if(GIT)
    execute_process(
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        COMMAND ${GIT} rev-parse --short HEAD
        OUTPUT_VARIABLE GIT_OUT OUTPUT_STRIP_TRAILING_WHITESPACE
        )
    if(GIT_OUT)
        set(CPACK_PACKAGE_VERSION_PATCH "${CPACK_PACKAGE_VERSION_PATCH}-${GIT_OUT}")
    else()
        set(CPACK_PACKAGE_VERSION_PATCH "${CPACK_PACKAGE_VERSION_PATCH}")
    endif()
endif(GIT)

set(CPACK_PACKAGE_VERSION ${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH})
set(PROJECT_VERSION ${CPACK_PACKAGE_VERSION})

message(STATUS "Version: ${PROJECT_VERSION}")

cmake_host_system_information(RESULT BUILD_HOST QUERY HOSTNAME)
set(BUILD_USER $ENV{USER})
configure_file(cmake/version.h config/version.h)


#
# Declare source and header files.
#
set(SRC_FILES
    # Dialogs
    src/dialogs/CreateRoom.cpp
    src/dialogs/ImageOverlay.cpp
    src/dialogs/PreviewUploadOverlay.cpp
    src/dialogs/InviteUsers.cpp
    src/dialogs/JoinRoom.cpp
    src/dialogs/MemberList.cpp
    src/dialogs/LeaveRoom.cpp
    src/dialogs/Logout.cpp
    src/dialogs/UserProfile.cpp
    src/dialogs/ReadReceipts.cpp
    src/dialogs/ReCaptcha.cpp
    src/dialogs/RoomSettings.cpp

    # Emoji
    src/emoji/Category.cpp
    src/emoji/ItemDelegate.cpp
    src/emoji/Panel.cpp
    src/emoji/PickButton.cpp
    src/emoji/Provider.cpp

    # Timeline
    src/timeline/TimelineViewManager.cpp
    src/timeline/TimelineItem.cpp
    src/timeline/TimelineView.cpp
    src/timeline/widgets/AudioItem.cpp
    src/timeline/widgets/FileItem.cpp
    src/timeline/widgets/ImageItem.cpp
    src/timeline/widgets/VideoItem.cpp

    # UI components
    src/ui/Avatar.cpp
    src/ui/Badge.cpp
    src/ui/LoadingIndicator.cpp
    src/ui/InfoMessage.cpp
    src/ui/FlatButton.cpp
    src/ui/FloatingButton.cpp
    src/ui/Label.cpp
    src/ui/OverlayModal.cpp
    src/ui/ScrollBar.cpp
    src/ui/SnackBar.cpp
    src/ui/RaisedButton.cpp
    src/ui/Ripple.cpp
    src/ui/RippleOverlay.cpp
    src/ui/OverlayWidget.cpp
    src/ui/TextField.cpp
    src/ui/ToggleButton.cpp
    src/ui/Theme.cpp
    src/ui/ThemeManager.cpp

    src/AvatarProvider.cpp
    src/Cache.cpp
    src/ChatPage.cpp
    src/CommunitiesListItem.cpp
    src/CommunitiesList.cpp
    src/InviteeItem.cpp
    src/LoginPage.cpp
    src/Logging.cpp
    src/MainWindow.cpp
    src/MatrixClient.cpp
    src/QuickSwitcher.cpp
    src/Olm.cpp
    src/RegisterPage.cpp
    src/RoomInfoListItem.cpp
    src/RoomList.cpp
    src/RunGuard.cpp
    src/SideBarActions.cpp
    src/Splitter.cpp
    src/SuggestionsPopup.cpp
    src/TextInputWidget.cpp
    src/TopRoomBar.cpp
    src/TrayIcon.cpp
    src/TypingDisplay.cpp
    src/Utils.cpp
    src/UserInfoWidget.cpp
    src/UserSettingsPage.cpp
    src/WelcomePage.cpp
    src/main.cpp
)

# ExternalProject dependencies
set(EXTERNAL_PROJECT_DEPS "")

set(Boost_USE_STATIC_LIBS OFF)
set(Boost_USE_STATIC_RUNTIME OFF)
set(Boost_USE_MULTITHREADED ON)
find_package(Boost 1.66 REQUIRED
             COMPONENTS atomic
                        chrono
                        date_time
                        iostreams
                        random
                        regex
                        system
                        thread)
find_package(ZLIB REQUIRED)
find_package(OpenSSL REQUIRED)
find_package(MatrixClient 0.1.0 REQUIRED)
find_package(Olm 2 REQUIRED)
find_package(spdlog 1.0.0 CONFIG REQUIRED)
find_package(cmark REQUIRED)

if(NOT LMDBXX_INCLUDE_DIR)
    find_path(LMDBXX_INCLUDE_DIR
            NAMES lmdb++.h
            PATHS /usr/include
                  /usr/local/include
                  $ENV{LIB_DIR}/include
                  $ENV{LIB_DIR}/include/lmdbxx)
endif()
include_directories(SYSTEM ${LMDBXX_INCLUDE_DIR})

if(NOT TWEENY_INCLUDE_DIR)
    find_path(TWEENY_INCLUDE_DIR
            NAMES tweeny/tweeny.h
            PATHS /usr/include/
                  /usr/local/include/
                  $ENV{LIB_DIR}/include/
                  $ENV{LIB_DIR}/include/tweeny)
endif()
include_directories(SYSTEM ${TWEENY_INCLUDE_DIR})

include_directories(${CMAKE_SOURCE_DIR}/src)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/config)
include_directories(${Boost_INCLUDE_DIRS})

qt5_wrap_cpp(MOC_HEADERS
    # Dialogs
    src/dialogs/CreateRoom.h
    src/dialogs/ImageOverlay.h
    src/dialogs/PreviewUploadOverlay.h
    src/dialogs/InviteUsers.h
    src/dialogs/JoinRoom.h
    src/dialogs/MemberList.h
    src/dialogs/LeaveRoom.h
    src/dialogs/Logout.h
    src/dialogs/UserProfile.h
    src/dialogs/RawMessage.h
    src/dialogs/ReadReceipts.h
    src/dialogs/ReCaptcha.h
    src/dialogs/RoomSettings.h

    # Emoji
    src/emoji/Category.h
    src/emoji/ItemDelegate.h
    src/emoji/Panel.h
    src/emoji/PickButton.h

    # Timeline
    src/timeline/TimelineItem.h
    src/timeline/TimelineView.h
    src/timeline/TimelineViewManager.h
    src/timeline/widgets/AudioItem.h
    src/timeline/widgets/FileItem.h
    src/timeline/widgets/ImageItem.h
    src/timeline/widgets/VideoItem.h

    # UI components
    src/ui/Avatar.h
    src/ui/Badge.h
    src/ui/LoadingIndicator.h
    src/ui/InfoMessage.h
    src/ui/FlatButton.h
    src/ui/Label.h
    src/ui/FloatingButton.h
    src/ui/Menu.h
    src/ui/OverlayWidget.h
    src/ui/ScrollBar.h
    src/ui/SnackBar.h
    src/ui/RaisedButton.h
    src/ui/Ripple.h
    src/ui/RippleOverlay.h
    src/ui/TextField.h
    src/ui/ToggleButton.h
    src/ui/Theme.h
    src/ui/ThemeManager.h

    src/notifications/Manager.h

    src/AvatarProvider.h
    src/Cache.h
    src/ChatPage.h
    src/CommunitiesListItem.h
    src/CommunitiesList.h
    src/LoginPage.h
    src/MainWindow.h
    src/MatrixClient.h
    src/InviteeItem.h
    src/QuickSwitcher.h
    src/RegisterPage.h
    src/RoomInfoListItem.h
    src/RoomList.h
    src/SideBarActions.h
    src/Splitter.h
    src/SuggestionsPopup.h
    src/TextInputWidget.h
    src/TopRoomBar.h
    src/TrayIcon.h
    src/TypingDisplay.h
    src/UserInfoWidget.h
    src/UserSettingsPage.h
    src/WelcomePage.h
)

#
# Bundle translations.
#
include(Translations)
set(TRANSLATION_DEPS ${LANG_QRC} ${QRC} ${QM_SRC})

set(COMMON_LIBS
    MatrixClient::MatrixClient
    ${Boost_LIBRARIES}
    cmark::cmark
    Qt5::Widgets
    Qt5::Svg
    Qt5::Concurrent
    Qt5::Multimedia)

if(APPVEYOR_BUILD)
    set(NHEKO_LIBS ${COMMON_LIBS} lmdb)
else()
    set(NHEKO_LIBS ${COMMON_LIBS} ${LMDB_LIBRARY})
endif()

if (APPLE)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -framework Foundation -framework Cocoa")
    set(SRC_FILES ${SRC_FILES} src/notifications/ManagerMac.mm src/emoji/MacHelper.mm)
elseif (WIN32)
    file(DOWNLOAD
         "https://raw.githubusercontent.com/mohabouje/WinToast/41ed1c58d5dce0ee9c01dbdeac05be45358d4f57/src/wintoastlib.cpp"
         ${PROJECT_SOURCE_DIR}/src/wintoastlib.cpp
         EXPECTED_HASH SHA256=1A1A7CE41C1052B12946798F4A6C67CE1FAD209C967F5ED4D720B173527E2073)

    file(DOWNLOAD
         "https://raw.githubusercontent.com/mohabouje/WinToast/41ed1c58d5dce0ee9c01dbdeac05be45358d4f57/src/wintoastlib.h"
         ${PROJECT_SOURCE_DIR}/src/wintoastlib.h
         EXPECTED_HASH SHA256=b4481023c5782733795838be22bf1a75f45d87458cd4d9a5a75f664a146eea11)

    set(SRC_FILES ${SRC_FILES} src/notifications/ManagerWin.cpp src/wintoastlib.cpp)
else ()
    set(SRC_FILES ${SRC_FILES} src/notifications/ManagerLinux.cpp)
endif ()

set(NHEKO_DEPS
    ${SRC_FILES}
    ${UI_HEADERS}
    ${MOC_HEADERS}
    ${TRANSLATION_DEPS}
    ${META_FILES_TO_INCLUDE})

if(ASAN)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address,undefined")
endif()

if(APPLE)
    add_executable (nheko ${OS_BUNDLE} ${NHEKO_DEPS})
    target_link_libraries (nheko ${NHEKO_LIBS} Qt5::MacExtras)
elseif(WIN32)
    add_executable (nheko ${OS_BUNDLE} ${ICON_FILE} ${NHEKO_DEPS})
    target_link_libraries (nheko ${NTDLIB} ${NHEKO_LIBS} Qt5::WinMain)
else()
    add_executable (nheko ${OS_BUNDLE} ${NHEKO_DEPS})
    target_link_libraries (nheko ${NHEKO_LIBS} Qt5::DBus)
endif()

if(EXTERNAL_PROJECT_DEPS)
    add_dependencies(nheko ${EXTERNAL_PROJECT_DEPS})
endif()

if(UNIX AND NOT APPLE)
    install (TARGETS nheko RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")
    install (FILES "resources/nheko-16.png" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/16x16/apps" RENAME "nheko.png")
    install (FILES "resources/nheko-32.png" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/32x32/apps" RENAME "nheko.png")

=== deps/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
project(NHEKO_DEPS)

# Point CMake at any custom modules we may ship
list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()

set(DEPS_INSTALL_DIR "${CMAKE_BINARY_DIR}/usr"
    CACHE PATH "Dependencies install directory.")
set(DEPS_BIN_DIR "${DEPS_INSTALL_DIR}/bin"
    CACHE PATH "Dependencies binary install directory.")
set(DEPS_LIB_DIR "${DEPS_INSTALL_DIR}/lib"
    CACHE PATH "Dependencies library install directory.")
set(DEPS_BUILD_DIR "${CMAKE_BINARY_DIR}/build"
    CACHE PATH "Dependencies build directory.")
set(DEPS_DOWNLOAD_DIR "${DEPS_BUILD_DIR}/downloads"
    CACHE PATH "Dependencies download directory.")

option(USE_BUNDLED "Use bundled dependencies." ON)

option(USE_BUNDLED_BOOST "Use the bundled version of Boost." ${USE_BUNDLED})
option(USE_BUNDLED_CMARK "Use the bundled version of cmark." ${USE_BUNDLED})
option(USE_BUNDLED_SPDLOG "Use the bundled version of spdlog." ${USE_BUNDLED})
option(USE_BUNDLED_OLM "Use the bundled version of libolm." ${USE_BUNDLED})
option(USE_BUNDLED_TWEENY "Use the bundled version of Tweeny." ${USE_BUNDLED})
option(USE_BUNDLED_LMDBXX "Use the bundled version of lmdbxx." ${USE_BUNDLED})
option(USE_BUNDLED_MATRIX_CLIENT "Use the bundled version of mtxclient."
       ${USE_BUNDLED})

include(ExternalProject)

set(BOOST_URL
    https://dl.bintray.com/boostorg/release/1.68.0/source/boost_1_68_0.tar.bz2)
set(BOOST_SHA256
    7f6130bc3cf65f56a618888ce9d5ea704fa10b462be126ad053e80e553d6d8b7)

set(
  MTXCLIENT_URL
  https://github.com/mujx/mtxclient/archive/99ca7480d15a82a7b8c5099be5f076c0ceecc9f7.tar.gz
  )
set(MTXCLIENT_HASH
    e88a8c4473b6bc37c046779ea2345da00abb88a755447b9ac77ed76c89975e9d)

set(
  TWEENY_URL
  https://github.com/mobius3/tweeny/archive/b94ce07cfb02a0eb8ac8aaf66137dabdaea857cf.tar.gz
  )
set(TWEENY_HASH
    9a632b9da84823fae002ad5d9ba02c8d77c0a3810479974c6b637c5504165475)

set(
  LMDBXX_HEADER_URL
  https://raw.githubusercontent.com/bendiken/lmdbxx/0b43ca87d8cfabba392dfe884eb1edb83874de02/lmdb%2B%2B.h
  )
set(LMDBXX_HASH
    c57b501a4e8fa1187fa7fd348da415c7685a50a7cb25b17b3f257b9e9426f73d)

set(OLM_URL https://git.matrix.org/git/olm.git)
set(OLM_TAG 4065c8e11a33ba41133a086ed3de4da94dcb6bae)

set(CMARK_URL https://github.com/commonmark/cmark/archive/0.28.3.tar.gz)
set(CMARK_HASH acc98685d3c1b515ff787ac7c994188dadaf28a2d700c10c1221da4199bae1fc)

set(SPDLOG_URL https://github.com/gabime/spdlog/archive/v1.1.0.tar.gz)
set(SPDLOG_HASH
    3dbcbfd8c07e25f5e0d662b194d3a7772ef214358c49ada23c044c4747ce8b19)

set(JSON_HEADER_URL
    https://github.com/nlohmann/json/releases/download/v3.2.0/json.hpp)
set(JSON_HEADER_HASH
    ce6b5610a051ec6795fa11c33854abebb086f0fd67c311f5921c3c07f9531b44)

file(DOWNLOAD ${JSON_HEADER_URL} ${DEPS_INSTALL_DIR}/include/json.hpp
     EXPECTED_HASH SHA256=${JSON_HEADER_HASH})

if(USE_BUNDLED_BOOST)
  include(Boost)
endif()

if(USE_BUNDLED_SPDLOG)
  include(SpdLog)
endif()

if(USE_BUNDLED_OLM)
  include(Olm)
endif()

if(USE_BUNDLED_CMARK)
  include(cmark)
endif()

if(USE_BUNDLED_TWEENY)
  include(Tweeny)
endif()

if(USE_BUNDLED_LMDBXX)
  file(DOWNLOAD ${LMDBXX_HEADER_URL} ${DEPS_INSTALL_DIR}/include/lmdb++.h
       EXPECTED_HASH SHA256=${LMDBXX_HASH})
endif()

if(WIN32)
  if("${TARGET_ARCH}" STREQUAL "X86_64")
    set(TARGET_ARCH x64)
  elseif(TARGET_ARCH STREQUAL "X86")
    set(TARGET_ARCH ia32)
  endif()
endif()

add_custom_target(third-party ALL
                  COMMAND ${CMAKE_COMMAND} -E touch .third-party
                  DEPENDS ${THIRD_PARTY_DEPS})

if(USE_BUNDLED_MATRIX_CLIENT)
  include(MatrixClient)
  add_dependencies(MatrixClient third-party)
endif()

=== debian/changelog ===
nheko (0.6.1-3) unstable; urgency=medium

  * debian/rules: make cmake write to a dummy home directory. (Closes:
    #914065)

 -- Hubert Chathi <uhoreg@debian.org>  Tue, 20 Nov 2018 10:08:17 -0500

nheko (0.6.1-2) unstable; urgency=medium

  * debian/control: fix build-depends. (Closes: #913890)

 -- Hubert Chathi <uhoreg@debian.org>  Fri, 16 Nov 2018 11:24:13 -0500

nheko (0.6.1-1) unstable; urgency=medium

  * New upstream release. (Closes: #908101)
  * debian/control:
    * Update maintainer address. (Closes: #908089)
    * Add new build-depends, and sort the build-depends list.
  * debian/patches/*: Removed some no-longer-needed files, and moved a
    patch

 -- Hubert Chathi <uhoreg@debian.org>  Wed, 26 Sep 2018 19:17:51 -0400

=== debian/control ===
Source: nheko
Section: net
Priority: optional
Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@alioth-lists.debian.net>
Uploaders: Hubert Chathi <uhoreg@debian.org>
Build-Depends: cmake (>= 3.1)
 , debhelper (>=9)
 , dh-exec
 , g++ (>= 4:7)
 , libboost-dev (>= 1.66) | libboost1.67-dev
 , libboost-atomic-dev | libboost-atomic1.67-dev
 , libboost-chrono-dev | libboost-chrono1.67-dev
 , libboost-date-time-dev | libboost-date-time1.67-dev
 , libboost-iostreams-dev | libboost-iostreams1.67-dev
 , libboost-random-dev | libboost-random1.67-dev
 , libboost-regex-dev | libboost-regex1.67-dev
 , libboost-system-dev | libboost-system1.67-dev
 , libboost-thread-dev | libboost-thread1.67-dev
 , libcmark-dev
 , liblmdb++-dev
 , libolm-dev
 , libqt5svg5-dev
 , libspdlog-dev
 , libsodium-dev
 , libssl-dev
 , libtweeny-dev
 , ninja-build
 , nlohmann-json3-dev
 , qtbase5-dev (>= 5.7)
 , qtmultimedia5-dev
 , qttools5-dev
Standards-Version: 3.9.8
Homepage: https://github.com/mujx/nheko
Vcs-Git: https://salsa.debian.org/matrix-team/nheko.git
Vcs-Browser: https://salsa.debian.org/matrix-team/nheko

Package: nheko
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: ca-certificates
Description: desktop IM client for the Matrix protocol
 Nheko is a Qt-based chat client for Matrix, an open, federated communications
 protocol.  The motivation behind the project is to provide a native desktop
 app for Matrix that feels more like a mainstream chat app and less like an IRC
 client.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@ 

# set $HOME to a dummy directory, because cmake tries to write stuff to $HOME
override_dh_auto_build: FAKEHOME = HOME=$(CURDIR)/fakehome
override_dh_auto_build:
	[ -d fakehome ] || mkdir fakehome
	$(FAKEHOME) cmake -GNinja -Hmtxclient -B.deps -DCMAKE_VERBOSE_MAKEFILE=ON -DBUILD_LIB_TESTS=OFF
	$(FAKEHOME) cmake --build .deps
	$(FAKEHOME) cmake -GNinja -H. -Bbuild -DCMAKE_BUILD_TYPE=RelWithDebInfo -DCMAKE_INSTALL_PREFIX=.deps/usr -DCMAKE_VERBOSE_MAKEFILE=ON
	$(FAKEHOME) cmake --build build
	rm -rf fakehome

override_dh_auto_test:
	#

override_dh_auto_clean:
	rm -rf .deps build

make-orig-source: VERSION = `dpkg-parsechangelog | grep ^Version | sed 's/Version: \(.*\)-[^-]*/\1/'`
make-orig-source:
	tar czf ../nheko_$(VERSION).orig.tar.gz --exclude-vcs --exclude-backups --exclude /debian --exclude /mtxclient -C .. `basename $(CURDIR)`
	tar czf ../nheko_$(VERSION).orig-mtxclient.tar.gz --exclude-vcs --exclude-backups mtxclient

## nheko 0.6.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.11)
 
 option(APPVEYOR_BUILD "Build on appveyor" OFF)
 option(ASAN "Compile with address sanitizers" OFF)
@@ -16,7 +16,7 @@
 project(nheko LANGUAGES C CXX)
 set(CPACK_PACKAGE_VERSION_MAJOR "0")
 set(CPACK_PACKAGE_VERSION_MINOR "6")
-set(CPACK_PACKAGE_VERSION_PATCH "1")
+set(CPACK_PACKAGE_VERSION_PATCH "3")
 set(PROJECT_VERSION_MAJOR ${CPACK_PACKAGE_VERSION_MAJOR})
 set(PROJECT_VERSION_MINOR ${CPACK_PACKAGE_VERSION_MINOR})
 set(PROJECT_VERSION_PATCH ${CPACK_PACKAGE_VERSION_PATCH})
@@ -113,6 +113,13 @@
     endif()
 endif()
 
+if (MSVC)
+  set(
+      CMAKE_CXX_FLAGS
+      "${CMAKE_CXX_FLAGS} /bigobj"
+  )
+endif()
+
 if(NOT (CMAKE_BUILD_TYPE OR CMAKE_CONFIGURATION_TYPES))
     set(CMAKE_BUILD_TYPE "Debug" CACHE STRING
         "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
@@ -121,6 +128,17 @@
 else(NOT (CMAKE_BUILD_TYPE OR CMAKE_CONFIGURATION_TYPES))
     message("Build type set to '${CMAKE_BUILD_TYPE}'")
 endif(NOT (CMAKE_BUILD_TYPE OR CMAKE_CONFIGURATION_TYPES))
+
+set(SPDLOG_DEBUG_ON false)
+
+# Windows doesn't handle CMAKE_BUILD_TYPE.
+if(NOT WIN32)
+    if(${CMAKE_BUILD_TYPE} STREQUAL "Debug")
+        set(SPDLOG_DEBUG_ON true)
+    else()
+        set(SPDLOG_DEBUG_ON false)
+    endif()
+endif()
 
 find_program(GIT git)
 if(GIT)
@@ -143,7 +161,7 @@
 
 cmake_host_system_information(RESULT BUILD_HOST QUERY HOSTNAME)
 set(BUILD_USER $ENV{USER})
-configure_file(cmake/version.h config/version.h)
+configure_file(cmake/nheko.h config/nheko.h)
 
 
 #
@@ -189,13 +207,13 @@
     src/ui/FloatingButton.cpp
     src/ui/Label.cpp
     src/ui/OverlayModal.cpp
-    src/ui/ScrollBar.cpp
     src/ui/SnackBar.cpp
     src/ui/RaisedButton.cpp
     src/ui/Ripple.cpp
     src/ui/RippleOverlay.cpp
     src/ui/OverlayWidget.cpp
     src/ui/TextField.cpp
+    src/ui/TextLabel.cpp
     src/ui/ToggleButton.cpp
     src/ui/Theme.cpp
     src/ui/ThemeManager.cpp
@@ -273,8 +291,10 @@
 include_directories(SYSTEM ${TWEENY_INCLUDE_DIR})
 
 include_directories(${CMAKE_SOURCE_DIR}/src)
-include_directories(${CMAKE_CURRENT_BINARY_DIR}/config)
 include_directories(${Boost_INCLUDE_DIRS})
+
+# local inclue directory
+include_directories(includes)
 
 qt5_wrap_cpp(MOC_HEADERS
     # Dialogs
@@ -317,12 +337,12 @@
     src/ui/FloatingButton.h
     src/ui/Menu.h
     src/ui/OverlayWidget.h
-    src/ui/ScrollBar.h
     src/ui/SnackBar.h
     src/ui/RaisedButton.h
     src/ui/Ripple.h
     src/ui/RippleOverlay.h
     src/ui/TextField.h
+    src/ui/TextLabel.h
     src/ui/ToggleButton.h
     src/ui/Theme.h
     src/ui/ThemeManager.h
@@ -422,5 +442,3 @@
 
 if(UNIX AND NOT APPLE)
     install (TARGETS nheko RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")
-    install (FILES "resources/nheko-16.png" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/16x16/apps" RENAME "nheko.png")
-    install (FILES "resources/nheko-32.png" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/32x32/apps" RENAME "nheko.png")

=== Makefile ===
FILES=`find lib include tests examples -type f -type f \( -iname "*.cpp" -o -iname "*.hpp" \)`

SYNAPSE_IMAGE="avhost/docker-matrix:v0.33.4"

DEPS_BUILD_DIR=.deps
DEPS_SOURCE_DIR=deps

help: ## This help message
	@grep -E '^[0-9a-zA-Z_-]+:.*?## .*$$' $(MAKEFILE_LIST) | sort | awk 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-20s\033[0m %s\n", $$1, $$2}'
	@# Change the digit following by an 's' to adjust the width of the help text

third-party: ## Build & install third party dependencies
	@cmake -GNinja -H${DEPS_SOURCE_DIR} -B${DEPS_BUILD_DIR} -DCMAKE_BUILD_TYPE=Release -DUSE_BUNDLED_BOOST=OFF
	@cmake --build ${DEPS_BUILD_DIR}

debug: ## Create a debug build
	@cmake -GNinja -H. -Bbuild \
		-DCMAKE_BUILD_TYPE=Debug \
		-DCMAKE_EXPORT_COMPILE_COMMANDS=1 \
		-DOPENSSL_ROOT_DIR=/usr/local/opt/openssl \
		-DCMAKE_INSTALL_PREFIX=${DEPS_BUILD_DIR}/usr
	@cmake --build build

release: ## Create an optimized build
	@cmake -GNinja -H. -Bbuild \
		-DCMAKE_BUILD_TYPE=Release \
		-DOPENSSL_ROOT_DIR=/usr/local/opt/openssl \
		-DCMAKE_INSTALL_PREFIX=${DEPS_BUILD_DIR}/usr
	@cmake --build build

test: ## Run the tests
	@cd build/ && GTEST_COLOR=1 ctest --verbose

asan: ## Create a debug build using address sanitizers
	@cmake -GNinja -H. -Bbuild \
		-DCMAKE_BUILD_TYPE=Debug \
		-DOPENSSL_ROOT_DIR=/usr/local/opt/openssl \
		-DCMAKE_INSTALL_PREFIX=${DEPS_BUILD_DIR}/usr \
		-DASAN=1
	@cmake --build build

image:
	docker build -t mtxclient-dev .

synapse: ## Start a synapse instance on docker
	@docker run -v `pwd`/data:/data --rm \
		-e SERVER_NAME=localhost -e REPORT_STATS=no ${SYNAPSE_IMAGE} generate
	@./.ci/adjust-config.sh
	@docker run -d \
		--name synapse \
		-p 443:8448 \
		-p 8448:8448 \
		-p 8008:8008 \
		-v `pwd`/data:/data ${SYNAPSE_IMAGE} start
	@echo Waiting for synapse to start...
	@until curl -s -f -k https://localhost:443/_matrix/client/versions; do echo "Checking ..."; sleep 2; done
	@echo Register alice
	@docker exec synapse /bin/bash -c 'register_new_matrix_user --admin -u alice -p secret -c /data/homeserver.yaml http://localhost:8008'
	@echo Register bob
	@docker exec synapse /bin/bash -c 'register_new_matrix_user --admin -u bob -p secret -c /data/homeserver.yaml http://localhost:8008'
	@echo Register carl
	@docker exec synapse /bin/bash -c 'register_new_matrix_user --admin -u carl -p secret -c /data/homeserver.yaml http://localhost:8008'

stop-synapse: ## Stop any running instance of synapse
	@rm -rf ./data/*
	@docker rm -f synapse 2>&1>/dev/null

restart: stop-synapse synapse

lint: ## Run clang-format on the source code
	@clang-format -i ${FILES} && git diff --exit-code

clean: ## Delete the build directory
	rm -rf build

=== deps/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.11)
 project(NHEKO_DEPS)
 
 # Point CMake at any custom modules we may ship
@@ -30,6 +30,11 @@
 option(USE_BUNDLED_MATRIX_CLIENT "Use the bundled version of mtxclient."
        ${USE_BUNDLED})
 
+if(USE_BUNDLED_BOOST)
+  # bundled boost is 1.68, which requires CMake 3.12 or greater.
+  cmake_minimum_required(VERSION 3.12)
+endif()
+
 include(ExternalProject)
 
 set(BOOST_URL
@@ -39,10 +44,10 @@
 
 set(
   MTXCLIENT_URL
-  https://github.com/mujx/mtxclient/archive/99ca7480d15a82a7b8c5099be5f076c0ceecc9f7.tar.gz
+  https://github.com/Nheko-Reborn/mtxclient/archive/8659d011f93cad63de34a79f9b0543705d5da825.tar.gz
   )
 set(MTXCLIENT_HASH
-    e88a8c4473b6bc37c046779ea2345da00abb88a755447b9ac77ed76c89975e9d)
+  7857a16cd2dd9c42ab51a8c188f4c60ca318eabbd6f7fd5db6815e60ef1cd3ad)
 
 set(
   TWEENY_URL

=== debian/changelog ===
nheko (0.6.3-2) unstable; urgency=medium

  * Support v3 rooms (Closes: #926671)
  * debian/rules: clean up fakehome (Closes: #926680)
  * debian/README.source: fix filename (Closes: #926659)

 -- Hubert Chathi <uhoreg@debian.org>  Mon, 22 Apr 2019 14:42:00 -0400

nheko (0.6.3-1) unstable; urgency=medium

  * New upstream release.
    * Project is no longer dead. (Closes: #913726)
    * Update files to point to new upstream location.
    * Update copyright file.

 -- Hubert Chathi <uhoreg@debian.org>  Fri, 08 Feb 2019 15:35:59 -0500

=== debian/rules ===
--- 
+++ 
@@ -31,7 +31,7 @@
 	#
 
 override_dh_auto_clean:
-	rm -rf .deps build
+	rm -rf .deps build fakehome
 
 make-orig-source: VERSION = `dpkg-parsechangelog | grep ^Version | sed 's/Version: \(.*\)-[^-]*/\1/'`
 make-orig-source:

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
   https://github.com/Nheko-reborn/nheko/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## nheko 0.6.3.1%2Brb2

=== mtxclient/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

project(matrix_client VERSION 0.2.0 LANGUAGES CXX C)

option(ASAN "Compile with address sanitizers" OFF)
option(BUILD_LIB_TESTS "Build tests" ON)
option(BUILD_LIB_EXAMPLES "Build examples" ON)
option(COVERAGE "Calculate test coverage" OFF)
option(IWYU "Check headers with include-what-you-use" OFF)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

add_definitions(-DBOOST_MPL_LIMIT_LIST_SIZE=30)
add_definitions(-DBOOST_MPL_CFG_NO_PREPROCESSED_HEADERS)

if(NOT MSVC)
  set(
    CMAKE_CXX_FLAGS
    "${CMAKE_CXX_FLAGS} \
        -Wall \
        -Wextra \
        -pipe \
        -pedantic \
        -fsized-deallocation \
        -fdiagnostics-color=always \
        -Wunreachable-code"
    )
endif()

if(ASAN)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address,undefined")
endif()

if(COVERAGE)
  include(CodeCoverage)
  add_custom_target(ctest COMMAND ${CMAKE_CTEST_COMMAND})
  set(CMAKE_CXX_FLAGS
      "${CMAKE_CXX_FLAGS} -g -O0 -fprofile-arcs -ftest-coverage")
  setup_target_for_coverage(test_coverage ctest coverage)
endif()

if(NOT MSVC AND NOT APPLE)
  set(THREADS_PREFER_PTHREAD_FLAG ON)
  find_package(Threads REQUIRED)
endif()

find_package(OpenSSL REQUIRED)
find_package(ZLIB REQUIRED)
find_package(Olm 2 REQUIRED)
find_package(sodium REQUIRED)

set(Boost_USE_STATIC_LIBS OFF)
set(Boost_USE_STATIC_RUNTIME OFF)
set(Boost_USE_MULTITHREADED ON)
find_package(Boost 1.66 REQUIRED
             COMPONENTS atomic
                        chrono
                        date_time
                        iostreams
                        random
                        regex
                        system
                        thread)

add_library(matrix_client
            lib/http/client.cpp
            lib/http/session.cpp
            lib/crypto/client.cpp
            lib/utils.cpp
            lib/structs/common.cpp
            lib/structs/errors.cpp
            lib/structs/events.cpp
            lib/structs/requests.cpp
            lib/structs/events/aliases.cpp
            lib/structs/events/avatar.cpp
            lib/structs/events/canonical_alias.cpp
            lib/structs/events/common.cpp
            lib/structs/events/create.cpp
            lib/structs/events/encrypted.cpp
            lib/structs/events/encryption.cpp
            lib/structs/events/guest_access.cpp
            lib/structs/events/history_visibility.cpp
            lib/structs/events/join_rules.cpp
            lib/structs/events/member.cpp
            lib/structs/events/name.cpp
            lib/structs/events/pinned_events.cpp
            lib/structs/events/power_levels.cpp
            lib/structs/events/redaction.cpp
            lib/structs/events/tag.cpp
            lib/structs/events/topic.cpp
            lib/structs/events/messages/audio.cpp
            lib/structs/events/messages/emote.cpp
            lib/structs/events/messages/file.cpp
            lib/structs/events/messages/image.cpp
            lib/structs/events/messages/notice.cpp
            lib/structs/events/messages/text.cpp
            lib/structs/events/messages/video.cpp
            lib/structs/responses/common.cpp
            lib/structs/responses/create_room.cpp
            lib/structs/responses/crypto.cpp
            lib/structs/responses/empty.cpp
            lib/structs/responses/login.cpp
            lib/structs/responses/media.cpp
            lib/structs/responses/messages.cpp
            lib/structs/responses/notifications.cpp
            lib/structs/responses/profile.cpp
            lib/structs/responses/register.cpp
            lib/structs/responses/sync.cpp
            lib/structs/responses/version.cpp)
add_library(MatrixClient::MatrixClient ALIAS matrix_client)
target_include_directories(matrix_client
                           SYSTEM
                           PUBLIC
                           ${Boost_INCLUDE_DIRS}
                           ${OPENSSL_INCLUDE_DIR}
                           ${sodium_INCLUDE_DIR})
target_include_directories(
  matrix_client
  PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)
target_link_libraries(matrix_client
                      PUBLIC
                      ${Boost_LIBRARIES}
                      ${sodium_LIBRARY_RELEASE}
                      OpenSSL::Crypto
                      OpenSSL::SSL
                      Olm::Olm
                      ZLIB::ZLIB)

if(NOT MSVC AND NOT APPLE)
  target_link_libraries(matrix_client PUBLIC Threads::Threads)
endif()

if(IWYU)
  find_program(iwyu_path NAMES include-what-you-use iwyu)
  if(iwyu_path)
    set_property(TARGET matrix_client
                 PROPERTY CXX_INCLUDE_WHAT_YOU_USE ${iwyu_path})
  else()
    message(WARNING "Could not find the program include-what-you-use")
  endif()
endif()

if(BUILD_LIB_EXAMPLES)
  add_subdirectory(examples)
endif()

#
# Installation & Target configuration.
#
include(GNUInstallDirs)
set(INSTALL_CONFIGDIR ${CMAKE_INSTALL_LIBDIR}/cmake/MatrixClient)

install(TARGETS matrix_client
        EXPORT matrix_client-targets
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

set_target_properties(matrix_client PROPERTIES EXPORT_NAME MatrixClient)

install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(EXPORT matrix_client-targets
               FILE
               MatrixClientTargets.cmake
               NAMESPACE
               MatrixClient::
               DESTINATION
               ${INSTALL_CONFIGDIR})

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
  ${CMAKE_CURRENT_BINARY_DIR}/MatrixClientConfigVersion.cmake
  VERSION
  ${PROJECT_VERSION}
  COMPATIBILITY
  AnyNewerVersion)

configure_package_config_file(
  ${CMAKE_CURRENT_LIST_DIR}/cmake/MatrixClientConfig.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/MatrixClientConfig.cmake
  INSTALL_DESTINATION
  ${INSTALL_CONFIGDIR})

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/MatrixClientConfig.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/MatrixClientConfigVersion.cmake
              DESTINATION
              ${INSTALL_CONFIGDIR})

export(EXPORT
       matrix_client-targets
       FILE
       ${CMAKE_CURRENT_BINARY_DIR}/MatrixClientTargets.cmake
       NAMESPACE
       MatrixClient::)
export(PACKAGE MatrixClient)

set_property(TARGET matrix_client PROPERTY SOVERSION ${PROJECT_VERSION})

if(BUILD_LIB_TESTS)
  enable_testing()

  find_package(GTest REQUIRED)

  file(COPY tests/fixtures DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

  add_executable(client_api tests/client_api.cpp)
  target_link_libraries(client_api
                        MatrixClient::MatrixClient
                        GTest::GTest
                        GTest::Main)
  target_include_directories(client_api PRIVATE
                             ${CMAKE_CURRENT_SOURCE_DIR}/tests)

  add_executable(media_api tests/media_api.cpp)
  target_link_libraries(media_api
                        MatrixClient::MatrixClient
                        GTest::GTest
                        GTest::Main)
  target_include_directories(media_api PRIVATE
                             ${CMAKE_CURRENT_SOURCE_DIR}/tests)

  add_executable(e2ee tests/e2ee.cpp)
  target_link_libraries(e2ee
                        MatrixClient::MatrixClient
                        GTest::GTest
                        GTest::Main)
  target_include_directories(e2ee PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/tests)

  add_executable(utils tests/utils.cpp)
  target_link_libraries(utils
                        MatrixClient::MatrixClient
                        GTest::GTest
                        GTest::Main)
  target_include_directories(utils PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/tests)

  add_executable(connection tests/connection.cpp)
  target_link_libraries(connection
                        MatrixClient::MatrixClient
                        GTest::GTest
                        GTest::Main)
  target_include_directories(connection PRIVATE
                             ${CMAKE_CURRENT_SOURCE_DIR}/tests)

  add_executable(identifiers tests/identifiers.cpp)
  target_link_libraries(identifiers
                        MatrixClient::MatrixClient
                        GTest::GTest
                        GTest::Main)

  add_executable(events tests/events.cpp)
  target_link_libraries(events
                        MatrixClient::MatrixClient
                        GTest::GTest
                        GTest::Main)

  add_executable(messages tests/messages.cpp)
  target_link_libraries(messages
                        MatrixClient::MatrixClient
                        GTest::GTest
                        GTest::Main)

  add_executable(responses tests/responses.cpp)
  target_link_libraries(responses
                        MatrixClient::MatrixClient
                        GTest::GTest
                        GTest::Main)

  add_executable(requests tests/requests.cpp)
  target_link_libraries(requests
                        MatrixClient::MatrixClient
                        GTest::GTest
                        GTest::Main)

  add_executable(errors tests/errors.cpp)
  target_link_libraries(errors
                        MatrixClient::MatrixClient
                        GTest::GTest
                        GTest::Main)

  add_executable(crypto tests/crypto.cpp)
  target_link_libraries(crypto
                        MatrixClient::MatrixClient
                        GTest::GTest
                        GTest::Main)

  add_test(BasicConnectivity connection)
  add_test(ClientAPI client_api)
  add_test(MediaAPI media_api)
  add_test(Encryption e2ee)
  add_test(Utilities utils)
  add_test(Identifiers identifiers)
  add_test(Errors errors)
  add_test(CryptoStructs crypto)
  add_test(StateEvents events)
  add_test(RoomEvents messages)
  add_test(Responses responses)
  add_test(Requests requests)
endif()

=== mtxclient/examples/CMakeLists.txt ===
find_package(spdlog 1.0.0 CONFIG REQUIRED)

include_directories(../tests)

add_executable(room_feed room_feed.cpp)
target_link_libraries(room_feed MatrixClient::MatrixClient)

add_executable(simple_bot simple_bot.cpp)
target_link_libraries(simple_bot MatrixClient::MatrixClient)

add_executable(crypto_bot crypto_bot.cpp)
target_link_libraries(crypto_bot
                      spdlog::spdlog
                      MatrixClient::MatrixClient
                      Olm::Olm)

## nheko 0.6.3.1+rb2

=== mtxclient/deps/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
project(MTXCLIENT_DEPS)

# Point CMake at any custom modules we may ship
list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()

set(DEPS_INSTALL_DIR "${CMAKE_BINARY_DIR}/usr"
    CACHE PATH "Dependencies install directory.")
set(DEPS_BIN_DIR "${DEPS_INSTALL_DIR}/bin"
    CACHE PATH "Dependencies binary install directory.")
set(DEPS_LIB_DIR "${DEPS_INSTALL_DIR}/lib"
    CACHE PATH "Dependencies library install directory.")
set(DEPS_BUILD_DIR "${CMAKE_BINARY_DIR}/build"
    CACHE PATH "Dependencies build directory.")
set(DEPS_DOWNLOAD_DIR "${DEPS_BUILD_DIR}/downloads"
    CACHE PATH "Dependencies download directory.")

option(USE_BUNDLED "Use bundled dependencies." ON)

option(USE_BUNDLED_BOOST "Use the bundled version of Boost." ${USE_BUNDLED})
option(USE_BUNDLED_SPDLOG "Use the bundled version of spdlog." ${USE_BUNDLED})
option(USE_BUNDLED_OLM "Use the bundled version of libolm." ${USE_BUNDLED})
option(USE_BUNDLED_GTEST "Use the bundled version of Google Test."
       ${USE_BUNDLED})

option(USE_EXISTING_SRC_DIR
       "Skip download of deps sources in case of existing source directory."
       OFF)

include(ExternalProject)

set(BOOST_URL
    https://dl.bintray.com/boostorg/release/1.68.0/source/boost_1_68_0.tar.bz2)
set(BOOST_SHA256
    7f6130bc3cf65f56a618888ce9d5ea704fa10b462be126ad053e80e553d6d8b7)

set(GTEST_URL https://github.com/google/googletest/archive/release-1.8.0.tar.gz)
set(GTEST_SHA1 e7e646a6204638fe8e87e165292b8dd9cd4c36ed)

set(OLM_URL https://git.matrix.org/git/olm.git)
set(OLM_TAG 4065c8e11a33ba41133a086ed3de4da94dcb6bae)

set(SPDLOG_URL https://github.com/gabime/spdlog/archive/v1.1.0.tar.gz)
set(SPDLOG_HASH
    3dbcbfd8c07e25f5e0d662b194d3a7772ef214358c49ada23c044c4747ce8b19)

set(JSON_HEADER_URL
    https://github.com/nlohmann/json/releases/download/v3.2.0/json.hpp)
set(JSON_HEADER_HASH
    ce6b5610a051ec6795fa11c33854abebb086f0fd67c311f5921c3c07f9531b44)

file(DOWNLOAD ${JSON_HEADER_URL} ${DEPS_INSTALL_DIR}/include/json.hpp
     EXPECTED_HASH SHA256=${JSON_HEADER_HASH})

if(USE_BUNDLED_BOOST)
  include(Boost)
endif()

if(USE_BUNDLED_SPDLOG)
  include(SpdLog)
endif()

if(USE_BUNDLED_OLM)
  include(Olm)
endif()

if(USE_BUNDLED_GTEST)
  include(GoogleTest)
endif()

if(WIN32)
  if("${TARGET_ARCH}" STREQUAL "X86_64")
    set(TARGET_ARCH x64)
  elseif(TARGET_ARCH STREQUAL "X86")
    set(TARGET_ARCH ia32)
  endif()
endif()

add_custom_target(third-party ALL
                  COMMAND ${CMAKE_COMMAND} -E touch .third-party
                  DEPENDS ${THIRD_PARTY_DEPS})

=== debian/changelog ===
nheko (0.6.3.1+rb2-1+eagle) unstable; urgency=medium

  * update

 -- Matrix Packaging Team <pkg-matrix-maintainers@alioth-lists.debian.net>  Thu, 28 Jan 2021 19:55:24 +0800
